// -*-c++*-

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "attributeparam.h"
//#include "strategy.h"

#include <rcsc/player/player_agent.h>

// シュートパラメータはAngle(degree)
const double AttributeParam::OF_SHOOT_PARAM = 15.0 ; // BEFORE: 20.0
const double AttributeParam::DF_SHOOT_PARAM = 25.0 ;

// パス，ドリブルは距離
const double AttributeParam::OF_PASS_PARAM = 0.5 ;
const double AttributeParam::DF_PASS_PARAM = 0.5 ;
const double AttributeParam::OF_DRIBBLE_PARAM = 3.0 ;
const double AttributeParam::DF_DRIBBLE_PARAM = 3.0 ;

AttributeParam::AttributeParam() {
  //  Strategy::StrategyState sstate = Strategy::SS_Normal ;
} 

double
//AttributeParam::get_shoot_param( Strategy::StrategyState state )
AttributeParam::get_shoot_param( const long & gamecycle )
{
  double param = 0.0  ;

  switch( AttributeParam::get_strategy_state( gamecycle ) ) {
  case AttributeParam::SS_Offensive:
    param = AttributeParam::OF_SHOOT_PARAM ;
    break ;
  case AttributeParam::SS_Defensive:
    param = AttributeParam::DF_SHOOT_PARAM ;
    break ;
  default:
    param = 5.0 ;
    break ;
  }
  return param ;
}

double
AttributeParam::get_pass_param( const long & gamecycle )
{
  double param = 0.0  ;

  switch( AttributeParam::get_strategy_state( gamecycle ) ) {
  case AttributeParam::SS_Offensive:
    param = AttributeParam::OF_PASS_PARAM ;
    break ;
  case AttributeParam::SS_Defensive:
    param = AttributeParam::DF_PASS_PARAM ;
    break ;
  default:
    param = 5.0 ;
    break ;
  }
  return param ;
}

double
AttributeParam::get_dribble_param( const long & gamecycle )
{
  double param = 0.0 ;
  
  switch( AttributeParam::get_strategy_state( gamecycle ) ) {
  case AttributeParam::SS_Offensive:
    param = AttributeParam::OF_DRIBBLE_PARAM ;
    break ;
  case AttributeParam::SS_Defensive:
    param = AttributeParam::DF_DRIBBLE_PARAM ;
    break ;
  default:
    param = 5.0 ;
    break ;
  }
  return param ;
}

AttributeParam::StrategyState
AttributeParam::get_strategy_state( const long & gamecycle ) 
{
  if ( gamecycle > 4500 ) // default 4500
    {
      //      return AttributeParam::SS_Defensive ;
      return AttributeParam::SS_Offensive ;
    } 
  else
    {
      return AttributeParam::SS_Offensive ;
    }
  
  return AttributeParam::SS_None ;
}


